#include "allegro.h"
#include "levels.h"

//add pushable objects
//don't allow people to hang out of portals
//game ending
//max momentum, make so that there will be traps at the location where you would expect someone's momentum to run out &c.
//add pause after finishing level

void init();
void deinit();

int min(int a, int b)
{
	if (a<b) return a;
	else return b;    
}

int max(int a,int b)
{
	if (a>b)  return a;
	else return b;
}
const int pan = 128;
const int pitch = 1000;

int mode = 1;// 0 2d, 1 horizontal, 2 vertical

SAMPLE *sound[3];
const int S_FINISH=0;
const int S_SHOOT=1;
const int S_FAIL=2;

int colorkey[17];

int curlevel;
int px;
int py;  
int pm;
int pmdir;

const int displaysize=120;
const int leveloffset=0;
const int displayoffsety=0; //for y only
const int displayoffsetx=0;

const int tilesize=30;
int display[displaysize][displaysize];

BITMAP *buffer;


/* FRAMERATE CONTROL*/

void initlevel()
{
	/*     //draw background
     clear_to_color(bg,makecol(50,50,50));       
     
     //find where exit is; maybe encode starting point in similar manner? (and boulder things?)
	 
	 
     if (curlevel<levelcount-1)
     {
	 int ex;
	 int ey;
	 for (int i=0;i<levelsize;i++)
	 for (int j=0;j<levelsize;j++)
	 if (level[curlevel][j][i]==8)
	 {
	 ex=i;
	 ey=j;
	 }                       
	 
	 for (int i=0;i<levelsize;i++)
	 for (int j=0;j<levelsize;j++)
	 if (level[curlevel+1][j][i]>0)
	 {
	 int x = (leveloffset-displayoffsetx)*tilesize+ex*tilesize+1-startingpoint[curlevel+1][0]*(tilesize-1)+i*(tilesize-1);
	 int y = (leveloffset-displayoffsety)*tilesize+ey*tilesize+1-startingpoint[curlevel+1][1]*(tilesize-1)+j*(tilesize-1);
	 rectfill(bg,x,y,x+tilesize-2,y+tilesize-2,colorkey[level[curlevel+1][j][i]]);        
	 }
	 
     }*/
	
	for (int i=0;i<levelsize;i++)
		for (int j=0;j<levelsize;j++)
			if (level[curlevel][j][i]==S)
			{
				px=i;
				py=j;
			}	
	
	mode = 1;		
}

bool canmove(int x, int y)
{
	//	return ((level[curlevel][y][x]==2)||(level[curlevel][y][x]==8)||(level[curlevel][y][x]==11)||(level[curlevel][y][x]==14)||(level[curlevel][y][x]==15)||(level[curlevel][y][x]==16));
	if ((x>=0)&&(y>=0)&&(x<levelsize)&&(y<levelsize)) 
	{
		if (mode==1)//hor; scan the vertical rows
		{
			for (int j=0;j<levelsize;j++)
			{
				if (level[curlevel][j][x]==1)
					return false;
			}
		}
		else if (mode==2)//vert
		{
			for (int i=0;i<levelsize;i++)
			{
				if (level[curlevel][y][i]==1)
					return false;
			}			
		}
		
		//otherwise return true
		return true;
	}
	else return false;
}
/*
 bool canshoot(int x, int y)
 {
 return ((level[curlevel][y][x]==2)||(level[curlevel][y][x]==8)||(level[curlevel][y][x]==9)||(level[curlevel][y][x]==14)||(level[curlevel][y][x]==15)||(level[curlevel][y][x]==16));   
 }*/

volatile unsigned int frames, fps;
void second_counter(void)
{
	fps=frames;
	frames=0;
} END_OF_FUNCTION(second_counter);
int timewaster_delay;
extern void do_prog(void);

volatile unsigned int ticks;
void ticker(void)
{
	++ticks;
} END_OF_FUNCTION(ticker);


int main() {
    
	
	init();
	
	
	
	int shotcolor[2];
	shotcolor[0]=6;
	shotcolor[1]=7;
    
	while (!key[KEY_ESC]) 
	{
		//reset level
		/*          if (key[KEY_Q])
		 {
		 initlevel();
		 }          */
		
		
		
		{
			//clear screen contents
			for (int i=0;i<displaysize;i++)
				for (int j=0;j<displaysize;j++)
					display[i][j]=1;
			//momentum stuff
			
			
			if (mode==1)
			{
				//introduce acceleration later  
				if (key[KEY_RIGHT])
				{
					if  (canmove(px+1,py))
						px++; 
				}
				if (key[KEY_LEFT])
				{
					if (canmove(px-1,py))               
						px--; 
				}
			}			
			else if (mode==2)
			{
				if (key[KEY_DOWN])
				{
					if (canmove(px,py+1))
					{
						py++; 
					}
				}					
				//temp move up control to test stuff
				if (key[KEY_UP])
				{
					if  (canmove(px,py-1))
						py--; 
				}
			}
			else if (mode==0)
			{
				if (key[KEY_UP]||key[KEY_DOWN]) //mode to vertical
				{
					bool block=false;
					for (int i=0;i<levelsize;i++)
						if (level[curlevel][py][i]==1)
							block=true;
					if (!block)
					{
						mode=2;
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);				
					}
					else
						play_sample(sound[S_FAIL], 255, pan, pitch, FALSE);																		
				}
				else if (key[KEY_LEFT]||key[KEY_RIGHT])//mode to horizontal
				{
					bool block=false;
					for (int j=0;j<levelsize;j++)
						if (level[curlevel][j][px]==1)
							block=true;
					if (!block)
					{
						mode=1;					
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);											
					}
					else
						play_sample(sound[S_FAIL], 255, pan, pitch, FALSE);											
				}					
			}
			
			
			if (mode>0)
			{
				if (key[KEY_SPACE])
				{
					mode=0;
					play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);				
				}
			}
			
			
			
		}
		
		if (mode==1)//horizontal
		{
			bool endintersect=false;
			for (int j=0;j<levelsize;j++)
				if (level[curlevel][j][px]==F)
					endintersect=true;
			
			if (endintersect)
			{
				curlevel++;
				initlevel();
				play_sample(sound[S_FINISH], 255, pan, pitch, FALSE);				
			}
		}
		if (mode==2)//vertical
		{
			bool endintersect=false;
			for (int i=0;i<levelsize;i++)
				if (level[curlevel][py][i]==F)
					endintersect=true;
			
			if (endintersect)
			{
				curlevel++;
				initlevel();
				play_sample(sound[S_FINISH], 255, pan, pitch, FALSE);				
			}
		}			
		
		//draw basic level     
		if (mode==0)
		{
			for (int i=0;i<levelsize;i++)
				for (int j=0;j<levelsize;j++)
				{
					if (level[curlevel][j][i]==F)
						display[i+leveloffset][j+leveloffset]=F;
					else if (level[curlevel][j][i]==1)
						display[i+leveloffset][j+leveloffset]=4;
					else
						display[i+leveloffset][j+leveloffset]=0;
				}
		}
		else if (mode==1) //horizontal
		{
			for (int i=0;i<levelsize;i++)
			{	
				int candidate=0;
				for (int j=0;j<levelsize;j++)
					if (level[curlevel][j][i]>0)
					{
						if ((level[curlevel][j][i]==F) &&(candidate==0))
							candidate=F;
						if (level[curlevel][j][i]==1)							
							candidate=4;
					}
				display[i+leveloffset][py+leveloffset]=candidate;			
				
			}
		}	
		else if (mode==2) //vertical
		{
			for (int j=0;j<levelsize;j++)
			{	
				int candidate=0;
				for (int i=0;i<levelsize;i++)
					if (level[curlevel][j][i]>0)
					{
						if ((level[curlevel][j][i]==F) &&(candidate==0))
							candidate=F;
						if (level[curlevel][j][i]==1)							
							candidate=4;
					}
				display[px+leveloffset][j+leveloffset]=candidate;			
			}
		}
		
		//draw player
		display[px+leveloffset][py+leveloffset]=3;
		
		//draw screen contents;
		//          blit(bg,buffer, 0,0,0,0,800,600);
		clear_to_color(buffer,makecol(50,50,50));    
		for (int i=displayoffsetx;i<displaysize-displayoffsetx;i++)
			for (int j=displayoffsety;j<displaysize-displayoffsety;j++)
				rectfill(buffer,(i-displayoffsetx)*tilesize+100,(j-displayoffsety)*tilesize,(i-displayoffsetx)*tilesize+tilesize-1+100,(j-displayoffsety)*tilesize+tilesize-1,colorkey[display[i][j]]);
		
		
		/* control timing */
		while (ticks<1)
		{
			rest(0);
		}
		ticks=0;
		++frames;
		
		blit(buffer,screen, 0,0,0,0,800,600);
		
	}	
	
	
	
	deinit();
	return 0;
}
END_OF_MAIN()

void init() {
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}
	
	install_timer();
	install_keyboard();
	install_mouse();
	
	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	
	
	sound[0] = load_wav("finish.wav");                       
	sound[1] = load_wav("shoot.wav");            
	sound[2] = load_wav("fail.wav");            
	
	LOCK_FUNCTION(second_counter);
	LOCK_VARIABLE(fps);
	LOCK_VARIABLE(frames);
	LOCK_FUNCTION(ticker);
	LOCK_VARIABLE(ticks);
	
	
	frames=timewaster_delay=0;
	install_int_ex(second_counter, BPS_TO_TIMER(1));
	install_int_ex(ticker, BPS_TO_TIMER(10));
	
	
	int white=makecol(255,255,255);
	int offwhite=makecol(192,192,192);  
	int black=makecol(0,0,0);
	int blue=makecol(0,0,255);
	int pink=makecol(255,200,200);
	int aqua=makecol(200,200,255);
	//	int red=makecol(255,0,0);
	int green=makecol(0,255,0);
	int purple=makecol(255,0,255);
	int grey=makecol(50,50,50);
	int yellow=makecol(255,255,0);
	int brown=makecol(93,40,11);
	int darkyellow=makecol(128,128,0);
	colorkey[0]=black; //empty space
	colorkey[1]=grey; //impenetrable wall
	colorkey[2]=black; //walkable area
	colorkey[3]=green; //player
	colorkey[4]=white;   //WALL
	colorkey[5]=blue;  //portal chamber 2
	colorkey[6]=pink;  //portal blast 1
	colorkey[7]=aqua;  //portal blast 2
	colorkey[8]=yellow;//goal
	colorkey[9]=grey;  //barrier penetrable by blast
	colorkey[10]=blue;  //reflection of portal chambers
	colorkey[11]=purple;//lethal gass, penetrable by portal
	colorkey[12]=offwhite;//see how looks for mirror walls
	colorkey[13]=brown;//boulder
	colorkey[14]=darkyellow;//entrance
	colorkey[15]=black;//boulder roll left spawn point
	colorkey[16]=black;//boulder roll right spawn point
	buffer=create_bitmap(800,600);
	//        bg=create_bitmap(800,600);        
	curlevel=0;
	
	initlevel();
}

void deinit() {
	clear_keybuf();
	/* add other deinitializations here */
}
